      * Parametri call SCANSTR
       01  PARPSCS.
      *                                 *> In INPUT: -------------------
      **** rel 6.2
      *    05 PSCS-CAMPO    PIC X(100). *>  stringa
           05 PSCS-CAMPO    PIC X(500). *>  stringa
      ************
      *                                 *> In INPUT/OUTPUT: ------------
           05 PSCS-TFLD     PIC 9.      *>  tipo campo:
      *                                 *>     0 - auto-detect
      *                                 *>     1 - stringa
      *                                 *>     2 - numero
      *                                 *>     3 - data
      *                                 *>     4 - data (anno a 4)
           05 PSCS-FDAT     PIC 9.      *>  formato data:
      *                                 *>     0 - AMG
      *                                 *>     1 - A/M/G
      *                                 *>     2 - GMA
      *                                 *>     3 - G/M/A
      **** rel 6.2
           05 PSCS-FNUM     PIC X.      *>  notazione numero:
      *                                 *>     def: automatico
      *                                 *>     E: europea (nnn.nnn,dd)
      *                                 *>     A: americana (nnn,nnn.dd)
      ************
      *                                 *> In OUTPUT: ------------------
           05 PSCS-PRI      PIC 999.    *>  primo carattere valorizzato
           05 PSCS-ULT      PIC 999.    *>  ultimo carattere valorizzato
           05 PSCS-NUM      PIC S9(18). *>  numero
           05 PSCS-NDEC     PIC 99.     *>  numero decimali
           05 PSCS-DATA     PIC 9(5).   *>  data
      *
      * Per PSCS-TFLD = ZERO (auto-detect):
      *     ritorna in output PSCS-TFLD 1-4 per stringa riconosciuta
      *     ritorna in output PSCS-TFLD 0   per stringa vuota
      *     ritorna in output PSCS-FDAT 0-3 per formato data
      *     ATTENZIONE: - in auto-detect le date hanno priorita' sui
      *                   numeri (un numero compatibile con la sintassi
      *                   di una data [es.: 150205 o 20050401] viene
      *                   riconosciuto come data
      *                 - in auto-detect le date vengono verificate
      *                   in questa sequenza:
      *                      MOVE 3 TO PSCS-TFLD.       *> data (aa2)
      *                      MOVE ZERO TO PSCS-FDAT.    *> amg
      *
      *                      MOVE 3 TO PSCS-TFLD.       *> data (aa2)
      *                      MOVE 1 TO PSCS-FDAT.       *> a/m/g
      *
      *                      MOVE 4 TO PSCS-TFLD.       *> data (aa4)
      *                      MOVE ZERO TO PSCS-FDAT.    *> amg
      *
      *                      MOVE 4 TO PSCS-TFLD.       *> data (aa4)
      *                      MOVE 1 TO PSCS-FDAT.       *> a/m/g
      *
      *                      MOVE 3 TO PSCS-TFLD.       *> data (aa2)
      *                      MOVE 2 TO PSCS-FDAT.       *> gma
      *
      *                      MOVE 3 TO PSCS-TFLD.       *> data (aa2)
      *                      MOVE 3 TO PSCS-FDAT.       *> g/m/a
      *
      *                      MOVE 4 TO PSCS-TFLD.       *> data (aa4)
      *                      MOVE 2 TO PSCS-FDAT.       *> gma
      *
      *                      MOVE 4 TO PSCS-TFLD.       *> data (aa4)
      *                      MOVE 3 TO PSCS-FDAT.       *> g/m/a
      *
      * Per PSCS-TFLD > ZERO:
      *     ritorna in output PSCS-TFLD = ZERO per sintassi errata
      *
      * Per avere numero decimalizzato:
      *         05 num pic 9(ni)V9(nd).
      *         ....
      *         IF PSCS-NDEC > ZERO
      *            COMPUTE num = PSCS-NUM / (10 ** PSCS-NDEC)
      *         ELSE
      *            MOVE PSCS-NUM TO num.
