       IDENTIFICATION DIVISION.
       PROGRAM-ID. SCANSTR-71.
      *
      * Scan stringa
      *
      * Scandisce una sringa e:
      *   determina il tipo
      *      data, numero, stringa (default) per auto-detect
      *   verifica sintassi x tipo (data, numero in input
      *
      **** rel 6.0a
      * nuovo
      *************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       DATA DIVISION.
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'parcdt'.
       01  COMODI.
           05 IND      PIC 999 VALUE ZERO.
           05 MAX      PIC 999 VALUE ZERO.
           05 X-CAMPO  PIC X(18) VALUE ZERO.
           05 9-CAMPO REDEFINES X-CAMPO PIC 9(18).
           05 FLGE     PIC 9 VALUE ZERO.
           05 FLGS     PIC 9 VALUE ZERO.
           05 FLGD     PIC 9 VALUE ZERO.
           05 I-NUM    PIC 99 VALUE ZERO.
      **** rel 6.2
           05 NINT     PIC 99 VALUE ZERO.
           05 SEPD     PIC X  VALUE SPACE.
      ************

       LINKAGE SECTION.
           COPY 'parpscs-71'.
       PROCEDURE DIVISION USING PARPSCS.
       INIZIO.
           MOVE ZERO TO PSCS-PRI.
           MOVE ZERO TO PSCS-ULT.
           MOVE ZERO TO PSCS-NUM PSCS-NDEC PSCS-DATA.

           MOVE LENGTH OF PSCS-CAMPO TO MAX.

           MOVE 1 TO IND.
           PERFORM UNTIL PSCS-CAMPO(IND:) = SPACE OR IND > MAX
                   IF PSCS-CAMPO(IND:1) NOT = SPACE
                      MOVE IND TO PSCS-ULT
                      IF PSCS-PRI = ZERO
                         MOVE IND TO PSCS-PRI
                      END-IF
                   END-IF
                   ADD 1 TO IND.

           PERFORM VER-FLD THRU EX-VER-FLD.
      *
       ESCI.
           EXIT PROGRAM.
      *--------*
       VER-FLD.
           IF PSCS-ULT = ZERO GO TO EX-FLD-DATA.

           IF PSCS-TFLD NOT = ZERO GO TO NO-AUTO.

      * auto-detect data
           MOVE 3 TO PSCS-TFLD.       *> data (aa2)
           MOVE ZERO TO PSCS-FDAT.    *> amg
           PERFORM FLD-DATA THRU EX-FLD-DATA.
           IF PSCS-TFLD NOT = ZERO GO TO EX-VER-FLD.

           MOVE 3 TO PSCS-TFLD.       *> data (aa2)
           MOVE 1 TO PSCS-FDAT.       *> a/m/g
           PERFORM FLD-DATA THRU EX-FLD-DATA.
           IF PSCS-TFLD NOT = ZERO GO TO EX-VER-FLD.

           MOVE 4 TO PSCS-TFLD.       *> data (aa4)
           MOVE ZERO TO PSCS-FDAT.    *> amg
           PERFORM FLD-DATA THRU EX-FLD-DATA.
           IF PSCS-TFLD NOT = ZERO GO TO EX-VER-FLD.

           MOVE 4 TO PSCS-TFLD.       *> data (aa4)
           MOVE 1 TO PSCS-FDAT.       *> a/m/g
           PERFORM FLD-DATA THRU EX-FLD-DATA.
           IF PSCS-TFLD NOT = ZERO GO TO EX-VER-FLD.

           MOVE 3 TO PSCS-TFLD.       *> data (aa2)
           MOVE 2 TO PSCS-FDAT.       *> gma
           PERFORM FLD-DATA THRU EX-FLD-DATA.
           IF PSCS-TFLD NOT = ZERO GO TO EX-VER-FLD.

           MOVE 3 TO PSCS-TFLD.       *> data (aa2)
           MOVE 3 TO PSCS-FDAT.       *> g/m/a
           PERFORM FLD-DATA THRU EX-FLD-DATA.
           IF PSCS-TFLD NOT = ZERO GO TO EX-VER-FLD.

           MOVE 4 TO PSCS-TFLD.       *> data (aa4)
           MOVE 2 TO PSCS-FDAT.       *> gma
           PERFORM FLD-DATA THRU EX-FLD-DATA.
           IF PSCS-TFLD NOT = ZERO GO TO EX-VER-FLD.

           MOVE 4 TO PSCS-TFLD.       *> data (aa4)
           MOVE 3 TO PSCS-FDAT.       *> g/m/a
           PERFORM FLD-DATA THRU EX-FLD-DATA.
           IF PSCS-TFLD NOT = ZERO GO TO EX-VER-FLD.

           MOVE ZERO TO PSCS-FDAT.

      * auto-detect numero
           MOVE 2 TO PSCS-TFLD.
           PERFORM FLD-NUM THRU EX-FLD-NUM.
           IF PSCS-TFLD NOT = ZERO GO TO EX-VER-FLD.

      * auto-detect stringa (default)
           MOVE 1 TO PSCS-TFLD.
           GO TO EX-VER-FLD.

       NO-AUTO.
           IF PSCS-TFLD = 2
              PERFORM FLD-NUM THRU EX-FLD-NUM.
           IF PSCS-TFLD = 3 OR 4
              PERFORM FLD-DATA THRU EX-FLD-DATA.
       EX-VER-FLD.
           EXIT.
      *--------*
       FLD-NUM.
      * verifica correttezza sintattica numero
           MOVE ZERO TO FLGE FLGS FLGD X-CAMPO.
      **** rel 6.2
           MOVE ZERO TO NINT.
           MOVE SPACE TO SEPD.
      ************
           MOVE PSCS-ULT TO IND.
           MOVE 18 TO I-NUM.
           PERFORM UNTIL IND < PSCS-PRI OR
                         FLGE NOT = ZERO
      * carattere 0-9
                   IF PSCS-CAMPO(IND:1) NUMERIC
                      IF I-NUM NOT = ZERO
                         MOVE PSCS-CAMPO(IND:1) TO X-CAMPO(I-NUM:1)
                         SUBTRACT 1 FROM I-NUM
      **** rel 6.2
                         ADD 1 TO NINT
      ************
                      ELSE
                         MOVE 1 TO FLGE
                      END-IF
                   ELSE
      * segno
                      IF PSCS-CAMPO(IND:1) = '+' OR '-'
                         IF FLGS = ZERO AND
                            IND = PSCS-ULT OR = PSCS-PRI
                               IF PSCS-CAMPO(IND:1) = '+'
                                  MOVE 1 TO FLGS
                               ELSE
                                  MOVE 2 TO FLGS  *> numero negativo
                               END-IF
                         ELSE
                            MOVE 1 TO FLGE
                         END-IF
                      ELSE
      * separatore decimale
                         IF PSCS-CAMPO(IND:1) = ',' OR '.'
                            IF FLGD = ZERO
      **** rel 6.2
      *                        COMPUTE PSCS-NDEC = PSCS-ULT - IND
      *                        IF FLGS NOT = ZERO
      *                           SUBTRACT 1 FROM PSCS-NDEC
      *                        END-IF
      *                        MOVE 1 TO FLGD
                               IF NOT (PSCS-FNUM = 'E' OR 'A') OR
                                  (PSCS-FNUM = 'E' AND
                                   PSCS-CAMPO(IND:1) = ',') OR
                                  (PSCS-FNUM = 'A' AND
                                   PSCS-CAMPO(IND:1) = '.')
                                      COMPUTE PSCS-NDEC = PSCS-ULT - IND
                                      IF FLGS NOT = ZERO
                                         SUBTRACT 1 FROM PSCS-NDEC
                                      END-IF
                                      MOVE 1 TO FLGD
                                      MOVE PSCS-CAMPO(IND:1) TO SEPD
                                      SUBTRACT PSCS-NDEC FROM NINT
                               ELSE
                                  IF NOT (NINT = 3 OR 6 OR
                                                 9 OR 12 OR 15)
                                     MOVE 1 TO FLGE
                                  END-IF
                               END-IF
      ************
                            ELSE
      **** rel 6.2
      *                        MOVE 1 TO FLGE
      * verifica separatore migliaia...
                               IF PSCS-CAMPO(IND:1) = SEPD
                                  IF PSCS-NDEC = 3 AND
                                     NINT = 3 OR 6 OR 9 OR 12 OR 15
                                        ADD PSCS-NDEC TO NINT
                                        MOVE ZERO TO PSCS-NDEC
                                        MOVE SPACE TO SEPD
                                  ELSE
                                     MOVE 1 TO FLGE
                               ELSE
                                  IF NOT (NINT = 3 OR 6 OR
                                                 9 OR 12 OR 15)
                                     MOVE 1 TO FLGE
                                  END-IF
                               END-IF
      ************
                            END-IF
                         ELSE
      * carattere non previsto
                            MOVE 1 TO FLGE
                         END-IF
                      END-IF
                   END-IF
                   SUBTRACT 1 FROM IND.

           IF FLGE = ZERO
              MOVE 9-CAMPO TO PSCS-NUM
              IF FLGS = 2
                 MULTIPLY -1 BY PSCS-NUM
              END-IF
           ELSE
              MOVE ZERO TO PSCS-TFLD
              MOVE ZERO TO PSCS-NDEC.

       EX-FLD-NUM.
           EXIT.
      *--------*
       FLD-DATA.
      * verifica correttezza sintattica data
           MOVE PSCS-PRI TO IND.
           MOVE ZERO TO GGMMAA.
           MOVE 1 TO TIPOP1.
      * data anno a 2
           IF PSCS-TFLD = 3                    *> data (aa2)
              IF PSCS-CAMPO(IND:2) NUMERIC
                 IF PSCS-FDAT = ZERO OR 1      *> amg a/m/g
                    MOVE PSCS-CAMPO(IND:2) TO AA9
                 END-IF
                 IF PSCS-FDAT = 2 OR 3         *> gma g/m/a
                    MOVE PSCS-CAMPO(IND:2) TO GG9
                 END-IF
                 ADD 2 TO IND
                 IF PSCS-FDAT = 1 OR 3
                    IF PSCS-CAMPO(IND:1) NOT NUMERIC
                       ADD 1 TO IND
                    ELSE
                       GO TO ERR-DATA
                    END-IF
                 END-IF
              ELSE
                 GO TO ERR-DATA
              END-IF
              IF PSCS-CAMPO(IND:2) NUMERIC
                 MOVE PSCS-CAMPO(IND:2) TO MM9
                 ADD 2 TO IND
                 IF PSCS-FDAT = 1 OR 3
                    IF PSCS-CAMPO(IND:1) NOT NUMERIC
                       ADD 1 TO IND
                    ELSE
                       GO TO ERR-DATA
                    END-IF
                 END-IF
              ELSE
                 GO TO ERR-DATA
              END-IF
              IF PSCS-CAMPO(IND:2) NUMERIC
                 IF PSCS-FDAT = ZERO OR 1      *> amg a/m/g
                    MOVE PSCS-CAMPO(IND:2) TO GG9
                 END-IF
                 IF PSCS-FDAT = 2 OR 3         *> gma g/m/a
                    MOVE PSCS-CAMPO(IND:2) TO AA9
                 END-IF
                 ADD 2 TO IND
              ELSE
                 GO TO ERR-DATA
              END-IF
              IF PSCS-CAMPO(IND:) NOT = SPACE
                 GO TO ERR-DATA.

      * data anno a 4
           IF PSCS-TFLD = 4                   *> data (aa4)
              MOVE 4 TO TIPOP1
              IF PSCS-FDAT = ZERO OR 1        *> amg a/m/g
                 IF PSCS-CAMPO(IND:4) NUMERIC
                    MOVE PSCS-CAMPO(IND:4) TO AA4
                    ADD 4 TO IND
                 ELSE
                    GO TO ERR-DATA
                 END-IF
              END-IF
              IF PSCS-FDAT = 2 OR 3           *> gma g/m/a
                 IF PSCS-CAMPO(IND:2) NUMERIC
                    MOVE PSCS-CAMPO(IND:2) TO GG4
                    ADD 2 TO IND
                 ELSE
                    GO TO ERR-DATA
                 END-IF
              END-IF
              IF PSCS-FDAT = 1 OR 3
                 IF PSCS-CAMPO(IND:1) NOT NUMERIC
                    ADD 1 TO IND
                 ELSE
                    GO TO ERR-DATA
                 END-IF
              END-IF
              IF PSCS-CAMPO(IND:2) NUMERIC
                 MOVE PSCS-CAMPO(IND:2) TO MM4
                 ADD 2 TO IND
                 IF PSCS-FDAT = 1 OR 3
                    IF PSCS-CAMPO(IND:1) NOT NUMERIC
                       ADD 1 TO IND
                    ELSE
                       GO TO ERR-DATA
                    END-IF
                 END-IF
              ELSE
                 GO TO ERR-DATA
              END-IF
              IF PSCS-FDAT = ZERO OR 1         *> amg a/m/g
                 IF PSCS-CAMPO(IND:2) NUMERIC
                    MOVE PSCS-CAMPO(IND:2) TO GG4
                    ADD 2 TO IND
                 ELSE
                    GO TO ERR-DATA
                 END-IF
              END-IF
              IF PSCS-FDAT = 2 OR 3            *> gma g/m/a
                 IF PSCS-CAMPO(IND:4) NUMERIC
                    MOVE PSCS-CAMPO(IND:4) TO AA4
                    ADD 4 TO IND
                 ELSE
                    GO TO ERR-DATA
                 END-IF
              END-IF
              IF PSCS-CAMPO(IND:) NOT = SPACE
                 GO TO ERR-DATA.

           CALL 'rdata' USING PARCDT.
      * data OK
           IF SWRET1 = ZERO
              MOVE AAGGG TO PSCS-DATA
              GO TO EX-FLD-DATA.
      * data errata
       ERR-DATA.
           MOVE ZERO TO PSCS-TFLD.
       EX-FLD-DATA.
           EXIT.
      *--------*
