       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRGCZR. 
      *
      *    Interfaccia EXPCZR per scheda
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griczrsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griczr'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'parzf'.
           COPY 'parlk'.
       01  ID-CZR PIC X(50) VALUE 'cfgzor'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-CZR   PIC XX.
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(50).
           05 ULTI-COL PIC 999.
           05 COMODO   PIC 999.
           05 SAV-NCOLUTE PIC 999.

       LINKAGE SECTION.
           COPY 'griczrrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-CZR-CTRL
                                RG-CZR-REC
                                RA-CZR-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclczr'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-CZR-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-CZR-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-CZR-FUN   TO FUN.
           MOVE RG-CZR-IDX   TO IDX.
           MOVE RG-CZR-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-CZR-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'B' GO TO F-EXPSINO.
           IF FUN = 'C' GO TO F-EXPRESET.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 's' OR 'g' GO TO F-SPOSTA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vrgczr: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-CZR-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-CZR-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM CALCOLO-ULTI-COL THRU EX-CALCOLO-ULTI-COL.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-CZR-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK CFGZOR.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-CZR INVALID
              PERFORM INVK-CZR
              GO TO ERRIO.
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-CZR INVALID
              PERFORM INVK-CZR
              GO TO ERRIO.
           UNLOCK CFGZOR.
           GO TO FINE.
      * - - - - - *
       F-EXPSINO.
      * cambia il flag di esportazione, se necessario setta il ncolonna
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-CZR
              GO TO WARNING.
           IF RG-CZR-ST = 7 GO TO FINE.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
      *
           IF RG-CZR-EXP = 1 
              MOVE ZERO TO RG-CZR-EXP
           ELSE 
              MOVE 1 TO RG-CZR-EXP.
      *
           IF RG-CZR-NCOLUTE = 999  
              PERFORM CALCOLO-ULTI-COL THRU EX-CALCOLO-ULTI-COL.
           IF RG-CZR-EXP = ZERO
              PERFORM SPOSTA-TUTTOINSU THRU EX-SPOSTA-TUTTOINSU
              MOVE 999 TO RG-CZR-NCOLUTE.
      *
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-CZR INVALID
              PERFORM INVK-CZR
              GO TO ERRIO.
           UNLOCK CFGZOR.
           GO TO FINE.
      * - - - - - *
       F-EXPRESET.
           IF (RG-CZR-RESEXP  = ZERO) AND 
              (RG-CZR-RESNCOLUTE = ZERO) GO TO C99.

      * azzero numero ultima colonna 
      *
           MOVE RG-CZR-COD TO KCZR-COD.
           MOVE RG-CZR-AZI TO KCZR-AZI.
           MOVE RG-CZR-UTE TO KCZR-UTE.
           MOVE LOW-VALUE   TO KCZR-FLD.
           MOVE ZERO        TO CZR-NCOLUTE.
      *
           START CFGZOR KEY NOT < KEYCZR INVALID GO TO C99.
       C10.
           READ CFGZOR NEXT AT END GO TO C99.
           IF SF-CZR = '9D' OR '9A' OR '35' GO TO C10.
           IF KCZR-COD NOT = RG-CZR-COD GO TO C99.
           IF KCZR-AZI NOT = RG-CZR-AZI GO TO C99.
           IF KCZR-UTE NOT = RG-CZR-UTE GO TO C99.
       C20.
           IF (RG-CZR-RESEXP  = 1) MOVE ZERO TO CZR-EXP.
           IF (RG-CZR-RESNCOLUTE = 1) MOVE 999  TO CZR-NCOLUTE.
      *
           REWRITE RF-CZR INVALID
              PERFORM INVK-CZR
              GO TO ERRIO.
           UNLOCK CFGZOR.
           GO TO C10.
       C99.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-CZR
              GO TO WARNING.
           IF RG-CZR-ST = 7 GO TO FINE.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
           DELETE CFGZOR INVALID
              PERFORM INVK-CZR
              GO TO ERRIO.
           UNLOCK CFGZOR.
           GO TO FINE.
      * - - - - - *
       F-SPOSTA.
           MOVE RG-CZR-COD TO KCZR-COD.
           MOVE RG-CZR-AZI TO KCZR-AZI.
           MOVE RG-CZR-UTE TO KCZR-UTE.
           MOVE RG-CZR-FLD TO KCZR-FLD.
           READ CFGZOR INVALID GO TO FINE.
           IF CZR-NCOLUTE = '999' GO TO FINE.
           MOVE CZR-NCOLUTE TO RG-CZR-NCOLUTE.
      *
           MOVE RG-CZR-COD     TO KCZR-COD.
           MOVE RG-CZR-AZI     TO KCZR-AZI.
           MOVE RG-CZR-UTE     TO KCZR-UTE.
           MOVE LOW-VALUE      TO KCZR-FLD.
           MOVE RG-CZR-NCOLUTE TO CZR-NCOLUTE.
           IF FUN = 's' 
              MOVE LOW-VALUE   TO KCZR-FLD
              START CFGZOR KEY < SKEYCZR3 INVALID GO TO S99
           ELSE
              MOVE HIGH-VALUE  TO KCZR-FLD
              START CFGZOR KEY > SKEYCZR3 INVALID GO TO S99.
       S10.
           IF FUN = 's' 
              READ CFGZOR PREVIOUS AT END GO TO S99
           ELSE
              READ CFGZOR NEXT AT END GO TO S99.
           IF SF-CZR = '9D' OR '9A' OR '35' GO TO S10.
           IF KCZR-COD NOT = RG-CZR-COD GO TO S99.
           IF KCZR-AZI NOT = RG-CZR-AZI GO TO S99.
           IF KCZR-UTE NOT = RG-CZR-UTE GO TO S99.
      *    
       S15.
           READ CFGZOR KEPT LOCK INVALID
              PERFORM INVK-CZR
              GO TO ERRIO.
           IF SF-CZR > ZERO PERFORM REC-LOCK
                            GO TO S15.
           IF CZR-NCOLUTE = '999' 
              UNLOCK CFGZOR
              MOVE RG-CZR-COD TO KCZR-COD
              MOVE RG-CZR-AZI TO KCZR-AZI
              MOVE RG-CZR-UTE TO KCZR-UTE
              MOVE RG-CZR-FLD TO KCZR-FLD
              READ CFGZOR
              GO TO FINE.
      *
           MOVE CZR-NCOLUTE TO SAV-NCOLUTE.
           MOVE RG-CZR-NCOLUTE TO CZR-NCOLUTE.
           REWRITE RF-CZR INVALID
              PERFORM INVK-CZR
              GO TO ERRIO.
           UNLOCK CFGZOR.
       S20.
           MOVE RG-CZR-COD TO KCZR-COD.
           MOVE RG-CZR-AZI TO KCZR-AZI.
           MOVE RG-CZR-UTE TO KCZR-UTE.
           MOVE RG-CZR-FLD TO KCZR-FLD.
           READ CFGZOR KEPT LOCK INVALID
              PERFORM INVK-CZR
              GO TO ERRIO.
           IF SF-CZR > ZERO PERFORM REC-LOCK
                            GO TO S20.
      *
           MOVE SAV-NCOLUTE TO CZR-NCOLUTE RG-CZR-NCOLUTE.
           REWRITE RF-CZR INVALID
              PERFORM INVK-CZR
              GO TO ERRIO.
           UNLOCK CFGZOR.
       S99.
           SUBTRACT 2 FROM RG-CZR-NCOLUTE.
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-CZR-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK CFGZOR.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-CZR-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABELL.
           CLOSE CFGZOR.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-CZR-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-CZR-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griczrer'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
      **** rel 7.1
           MOVE 'cfgzor' TO ID-CZR.
           IF NOT (EX-DFL = SPACE OR LOW-VALUE) AND
              NOT (EX-FL = SPACE OR LOW-VALUE)
                 MOVE SPACE TO ID-CZR
                 STRING EX-DFL EX-FL DELIMITED SPACE '\cfgzor'
                        INTO ID-CZR.
      ************
           OPEN INPUT TABELL.
           OPEN I-O CFGZOR.
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-CZR-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-CZR.
           MOVE SPACE TO KCZR-COD KCZR-FLD CZR-DES CZR-INTC.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
      * azzeramento aree interfaccia
           MOVE ZERO TO RG-CZR-REC RG-CZR-AZI.
           MOVE SPACE TO RG-CZR-COD RG-CZR-UTE RG-CZR-FLD
                         RG-CZR-DES1 RG-CZR-DES2
                         RG-CZR-INTC.
      **************
           MOVE ZERO TO RA-CZR-AGG.
      * ripristino dei campi chiave fissi
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
           MOVE 1 TO RG-CZR-EXP.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-CZR-COD TO KCZR-COD.
           MOVE RG-CZR-AZI TO KCZR-AZI.
           MOVE RG-CZR-UTE TO KCZR-UTE.
           MOVE RG-CZR-FLD TO KCZR-FLD.
           MOVE KEYCZR TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYCZR. 
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ CFGZOR INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ CFGZOR KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-CZR > ZERO MOVE 7 TO RG-CZR-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
      * posizionamento su chiave secondaria per successive
      * read next/previous
      *
       SET-KEYSEC.
           MOVE KEYCZR TO KRIFER.
           IF IDX = 2
              START CFGZOR KEY >= SKEYCZR3 INVALID GO TO SET-90.
       SET-10.
           READ CFGZOR NEXT AT END GO TO SET-90.
           IF KEYCZR = KRIFER GO TO EX-SET-KEYSEC.
           GO TO SET-10.
       SET-90.
           MOVE 'vrgdtr: errore di posizionamento su' TO F-MES1.
           MOVE 'chiave secondaria'                   TO F-MES2.
           MOVE 2 TO F-NMES.
           GO TO ERRIO.
       EX-SET-KEYSEC.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
           IF IDX > 1 PERFORM SET-KEYSEC THRU EX-SET-KEYSEC.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ CFGZOR PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              READ CFGZOR NEXT AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-CZR = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-CZR-EOF.
           MOVE KEYCZR TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-CZR-EOF.
           IF RG-CZR-EOF = 4 MOVE 2 TO RG-CZR-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
           IF RF-CZR = LOW-VALUE GO TO EX-TEST-EOL.
      *    IF IDX > 1 GO TO TEST-EOL-IDX2.
           IF KCZR-COD = RG-CZR-COD AND
              KCZR-AZI = RG-CZR-AZI AND
              KCZR-UTE = RG-CZR-UTE GO TO EX-TEST-EOL.
           IF FUN = 'P' OR 'p'
              MOVE 1 TO EOF
           ELSE
              MOVE 3 TO EOF.
           GO TO EX-TEST-EOL.
       TEST-EOL-IDX2.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-CZR-COD       TO KCZR-COD.
           MOVE RG-CZR-AZI       TO KCZR-AZI.
           MOVE RG-CZR-UTE       TO KCZR-UTE.
           MOVE RG-CZR-FLD       TO KCZR-FLD.
           MOVE RG-CZR-LUNG      TO CZR-LUNG.
           MOVE RG-CZR-TIPO      TO CZR-TIPO.
           MOVE RG-CZR-EXP       TO CZR-EXP.
           MOVE RG-CZR-DES1      TO CZR-DES1.
           MOVE RG-CZR-DES2      TO CZR-DES2.
           MOVE RG-CZR-INTC      TO CZR-INTC.
      *
           MOVE RG-CZR-NCOL      TO CZR-NCOL.
           MOVE RG-CZR-NCOLUTE   TO COMODO.
           IF COMODO NOT = 999 ADD 2 TO COMODO.
           MOVE COMODO           TO CZR-NCOLUTE.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE KCZR-COD      TO RG-CZR-COD.
           MOVE KCZR-AZI      TO RG-CZR-AZI.
           MOVE KCZR-UTE      TO RG-CZR-UTE.
           MOVE KCZR-FLD      TO RG-CZR-FLD.
           MOVE CZR-LUNG      TO RG-CZR-LUNG.
           MOVE CZR-TIPO      TO RG-CZR-TIPO.
           MOVE CZR-EXP       TO RG-CZR-EXP.
           MOVE CZR-DES1      TO RG-CZR-DES1.
           MOVE CZR-DES2      TO RG-CZR-DES2.
           MOVE CZR-INTC      TO RG-CZR-INTC.
      *
           MOVE CZR-NCOL      TO RG-CZR-NCOL.
           MOVE CZR-NCOLUTE   TO COMODO.
           IF COMODO NOT = 999 SUBTRACT 2 FROM COMODO.
           MOVE COMODO        TO RG-CZR-NCOLUTE.
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-CZR-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-CZR-FLD.
           MOVE 'KCZR-FLD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CZR-FLD.
           IF RG-CZR-FLD = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-CZR-FLD.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-CZR-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-LUNG.
           MOVE 'CZR-LUNG' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-LUNG.
           IF RG-CZR-LUNG = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-LUNG.
      *
       V-NCOLUTE.
           MOVE 'CZR-NCOLUTE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-NCOLUTE.
           IF RG-CZR-NCOLUTE = 0
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-NCOLUTE.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       CALCOLO-ULTI-COL.
      * cerca l'ultimo numero colonna valorizzato
           MOVE ZERO TO ULTI-COL.
           MOVE RG-CZR-COD TO KCZR-COD.
           MOVE RG-CZR-AZI TO KCZR-AZI.
           MOVE RG-CZR-UTE TO KCZR-UTE.
           MOVE HIGH-VALUE TO SKCZR-NCOLUTE.
           MOVE HIGH-VALUE TO KCZR-FLD.
           START CFGZOR KEY NOT > SKEYCZR3 INVALID GO TO END-CZR.
       LOOP-CZR.
           READ CFGZOR PREVIOUS AT END GO TO END-CZR.
           IF SF-CZR = '9D' OR '9A' OR '35' GO TO LOOP-CZR.
           IF KCZR-COD < RG-CZR-COD GO TO END-CZR.
           IF KCZR-AZI < RG-CZR-AZI GO TO END-CZR.
           IF KCZR-UTE < RG-CZR-UTE GO TO END-CZR.
      *
           IF CZR-NCOLUTE = 999 GO TO LOOP-CZR.
      *
           MOVE CZR-NCOLUTE TO ULTI-COL.
       END-CZR.
           IF ULTI-COL <= 999
              ADD 1 TO ULTI-COL
           ELSE
              MOVE ZERO TO ULTI-COL.
      *
           MOVE ULTI-COL   TO COMODO.
           IF ULTI-COL > 2 AND NOT = 999 SUBTRACT 2 FROM ULTI-COL.
           MOVE ULTI-COL TO RG-CZR-NCOLUTE.
       EX-CALCOLO-ULTI-COL.
           EXIT.
      *------------------
       REC-LOCK.
           CALL 'rlock' USING PARLK.
           EXIT.
      *------------------*
       SPOSTA-TUTTOINSU.
           MOVE RG-CZR-COD     TO KCZR-COD.
           MOVE RG-CZR-AZI     TO KCZR-AZI.
           MOVE RG-CZR-UTE     TO KCZR-UTE.
      *
           ADD 2 TO RG-CZR-NCOLUTE.
           MOVE RG-CZR-NCOLUTE TO SKCZR-NCOLUTE.
      *
           MOVE HIGH-VALUE     TO KCZR-FLD.
           START CFGZOR KEY > SKEYCZR3 INVALID GO TO END-CZR-S.
       LOOP-CZR-S.
           READ CFGZOR KEPT LOCK NEXT AT END GO TO END-CZR-S.
           IF SF-CZR = '9D' OR '9A' OR '35' GO TO LOOP-CZR-S.
           IF KCZR-COD NOT = RG-CZR-COD GO TO END-CZR-S.
           IF KCZR-AZI NOT = RG-CZR-AZI GO TO END-CZR-S.
           IF KCZR-UTE NOT = RG-CZR-UTE GO TO END-CZR-S.
      *
           IF CZR-NCOLUTE = 999 GO TO END-CZR-S.
      *
           SUBTRACT 1 FROM CZR-NCOLUTE.
           REWRITE RF-CZR INVALID PERFORM INVK-CZR
                                  GO TO ERRIO.
           UNLOCK CFGZOR.
      *
           GO TO LOOP-CZR-S.
       END-CZR-S.
       EX-SPOSTA-TUTTOINSU.
           EXIT.
      *------------------*
