       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRGCZT.
      **** rel 6.3
      * Nuovo
      ************
      *
      *    Interfaccia EXPCZT per scheda
      *
      * Nota: valori particolari di FUN
      *       W = valida tutto della scheda di gestione
      *       w = valida tutto della scheda di duplicazione
      *       c = copia distinta (duplicazione)
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'gricztsl'.
           COPY 'griczrsl'.
           COPY 'griazisl'.
           COPY 'gritutsl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griczt'.
           COPY 'griczr'.
           COPY 'griazi'.
           COPY 'gritut'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-71'.
           COPY 'griazirk'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-CZT PIC X(50) VALUE 'cfgzot'.
       01  ID-CZR PIC X(50) VALUE 'cfgzor'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TUT PIC X(15) VALUE 'tabute'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-CZT   PIC XX.
           05 SF-CZR   PIC XX.
           05 SF-AZI   PIC XX.
           05 SF-TUT   PIC XX.
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 IDX      PIC 9.
           05 EOF      PIC 9.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(50).
           05 COMTP1   PIC 9.
           05 PKDATA1  PIC 9(5)  COMP-3 VALUE ZERO.
           05 A-LOGNAME PIC X(10).

       LINKAGE SECTION.
           COPY 'gricztrg'.
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-CZT-CTRL
                                RG-CZT-REC
                                RA-CZT-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclczt'.
           COPY 'dclczr'.
           COPY 'dclazi'.
           COPY 'dcltut'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-CZT-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-CZT-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-CZT-FUN   TO FUN.
           MOVE RG-CZT-IDX   TO IDX.
           MOVE RG-CZT-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'I' GO TO F-INIINS.
           IF FUN = 'K' GO TO F-KEYINS.
           IF FUN = 'X' GO TO F-ANNINS.
           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        MOVE ZERO TO RG-CZT-EOF
                        GO TO F-READ.
           IF FUN = 'N' OR
                    'n' OR
                    'P' OR
                    'p' PERFORM READ-N-P THRU EX-READ-N-P
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'S' GO TO F-SCRIVI.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'c' GO TO F-DUPLIC.
           IF FUN = 'V' OR
                    'W' OR
                    'w' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'vrgczt: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-INIINS.
           MOVE ZERO TO RG-CZT-EOF.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM AZZ-RG-RA THRU EX-AZZ-RG-RA.
           PERFORM INI-CAMPI THRU EX-INI-CAMPI.
           GO TO FINE.
      * - - - - - *
       F-KEYINS.
           PERFORM MOVE-KEY.
           PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI.
           IF VFLD > ZERO
              MOVE VCAMPO TO RG-CZT-CAMPO
              GO TO ERRFIELD.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY = ZERO
              PERFORM AZZ-REC THRU EX-AZZ-REC
              PERFORM ERR-CPRE
              GO TO WARNING.
           PERFORM AZZ-REC THRU EX-AZZ-REC.
           PERFORM INS-OK  THRU EX-INS-OK.
           GO TO FINE.
      * - - - - - *
       F-ANNINS.
           IF FUN-PREC = 'X' GO TO FINE.
           PERFORM INS-NO THRU EX-INS-NO.
           GO TO FINE.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-CZT-ST = 7 GO TO FINE.
           IF FUN = 'r' PERFORM DB-STORNA THRU EX-DB-STORNA.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           UNLOCK CFGZOT.
           GO TO F-READ.
      * - - - - - *
       F-SCRIVI.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           WRITE RF-CZT INVALID
              PERFORM INVK-CZT
              GO TO ERRIO.
      *
           GO TO FINE.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           PERFORM DB-AGGIORNA THRU EX-DB-AGGIORNA.
           REWRITE RF-CZT INVALID
              PERFORM INVK-CZT
              GO TO ERRIO.
           UNLOCK CFGZOT.
           GO TO FINE.
      * - - - - - *
       F-DUPLIC.
           MOVE RG-CZT-COD    TO KCZT-COD.
           MOVE RG-CZT-AZIARR TO KCZT-AZI.
           MOVE RG-CZT-UTEARR TO KCZT-UTE.
           START CFGZOT KEY NOT < KEYCZT INVALID KEY GO TO OK-DUP.
       DUP-00.
           READ CFGZOT NEXT AT END GO TO OK-DUP.
           IF SF-CZT = '9D' OR '9A' OR '35' GO TO DUP-00.
           IF KCZT-COD > RG-CZT-COD   GO TO OK-DUP.
           IF KCZT-AZI > RG-CZT-AZIARR GO TO OK-DUP.
           IF KCZT-UTE > RG-CZT-UTEARR GO TO OK-DUP.
           MOVE 'Codice preesistente' TO MESS.
           GO TO ERRFIELD.
       OK-DUP.
           PERFORM DUPL THRU EX-DUPL.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-CZT
              GO TO WARNING.
           IF RG-CZT-ST = 7 GO TO FINE.
.          IF KCZT-AZI = ZERO AND KCZT-UTE = SPACE GO TO FINE.
           PERFORM C00-DEL-RIG THRU C99.
           PERFORM DB-STORNA THRU EX-DB-STORNA.
           DELETE CFGZOT INVALID
              PERFORM INVK-CZT
              GO TO ERRIO.
           UNLOCK CFGZOT.
           GO TO FINE.
      * - - - - - *
       C00-DEL-RIG.
           MOVE KCZT-COD  TO KCZR-COD.
           MOVE KCZT-AZI  TO KCZR-AZI.
           MOVE KCZT-UTE  TO KCZR-UTE.
           MOVE LOW-VALUE TO KCZR-FLD.
           START CFGZOR KEY NOT < KEYCZR INVALID GO TO C99.
       C10.
           READ CFGZOR NEXT AT END GO TO C99.
           IF SF-CZR = '9D' OR '9A' OR '35' GO TO C10.
           IF KCZR-COD NOT = KCZT-COD GO TO C99.
           IF KCZR-AZI NOT = KCZT-AZI GO TO C99.
           IF KCZR-UTE NOT = KCZT-UTE GO TO C99.
       C20.
           DELETE CFGZOR INVALID KEY
               PERFORM INVK-CZR
               GO TO ERRIO.
           UNLOCK CFGZOR.
           GO TO C10.
       C99.
           EXIT.
      * - - - - - *
       F-WALIDA.
           IF FUN = 'V'
              PERFORM V-CHIAVE THRU EX-V-CHIAVE-DATI
              IF VFLD > ZERO GO TO F-W90.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-CZT-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK CFGZOT.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-CZT-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE TABELL.
           CLOSE ANAAZI.
           CLOSE TABUTE.
           CLOSE CFGZOT.
           CLOSE CFGZOR.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-CZT-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-CZT-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griczter'.
           COPY 'griczrer'.
           COPY 'griazier'.
           COPY 'grituter'.
           COPY 'gritaber'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
      **** rel 7.1
           MOVE 'cfgzot' TO ID-CZT.
           MOVE 'cfgzor' TO ID-CZR.
           IF NOT (EX-DFL = SPACE OR LOW-VALUE) AND
              NOT (EX-FL = SPACE OR LOW-VALUE)
                 MOVE SPACE TO ID-CZT
                 STRING EX-DFL EX-FL DELIMITED SPACE '\cfgzot'
                        INTO ID-CZT
      *
                 MOVE SPACE TO ID-CZR
                 STRING EX-DFL EX-FL DELIMITED SPACE '\cfgzor'
                        INTO ID-CZR.
      ************
           OPEN INPUT TABELL.
           OPEN INPUT ANAAZI.
           OPEN INPUT TABUTE.
      *
           OPEN I-O CFGZOT.
           OPEN I-O CFGZOR.
      *
           MOVE 1 TO SWINI.
           MOVE ZERO TO RG-CZT-EOF.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       AZZ-REC.
           MOVE ZERO TO RF-CZT.
           MOVE SPACE TO KCZT-COD KCZT-UTE CZT-DES1 CZT-DES2 CZT-DES3.
       EX-AZZ-REC.
           EXIT.
      *------------------
       AZZ-RG-RA.
      *
      * salvataggio dei campi chiave fissi
      *    ( ed eventuali altri campi significativi passati in RG e RA )
      *
      * azzeramento aree interfaccia
           MOVE ZERO TO RG-CZT-REC.
           MOVE SPACE TO RG-CZT-COD RG-CZT-UTE 
                         RG-CZT-DES1 RG-CZT-DES2
                         RG-CZT-DES3.
      **************
           MOVE ZERO TO RA-CZT-AGG.
      *
      * ripristino dei campi chiave fissi
       EX-AZZ-RG-RA.
           EXIT.
      *------------------
      * inizializzazione campi non vuoti per inserimento (valori di
      * default di chiave o dati per aree di interfaccia)
       INI-CAMPI.
      *
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE GGMMAA TO RG-CZT-DATA. 
      *
           MOVE SPACE TO RG-CZT-UTE.
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * aggiornamento dati legati a conferma inserimento
       INS-OK.
       EX-INS-OK.
           EXIT.
      *------------------
      * ripristino dati correlati x annullamento inserimento
       INS-NO.
       EX-INS-NO.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE RG-CZT-COD TO KCZT-COD.
           MOVE RG-CZT-AZI TO KCZT-AZI.
           MOVE RG-CZT-UTE TO KCZT-UTE.
           MOVE KEYCZT TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYCZT. 
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ CFGZOT INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ CFGZOT KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           IF SF-CZT > ZERO MOVE 7 TO RG-CZT-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
      * posizionamento su chiave secondaria per successive
      * read next/previous
      *
       SET-KEYSEC.
       EX-SET-KEYSEC.
           EXIT.
      *------------------
       READ-N-P.
           MOVE ZERO TO EOF.
           IF IDX > 1 PERFORM SET-KEYSEC THRU EX-SET-KEYSEC.
       RNP-10.
           IF FUN = 'P' OR 'p'
              READ CFGZOT PREVIOUS AT END MOVE 1 TO EOF
           ELSE
              READ CFGZOT NEXT AT END MOVE 3 TO EOF.
           IF EOF > ZERO GO TO RNP-80.
           PERFORM TEST-EOL THRU EX-TEST-EOL.
           IF EOF > ZERO GO TO RNP-80.
           IF RF-CZT = LOW-VALUE GO TO RNP-10.
      *
      *    ( inserire qui eventuali controlli sui tipi record:
      *      se record da non trattare go to RNP-10          )
      *
      *    IF KCZT-COD NOT = RG-CZT-COD GO TO RNP-10.

      * trovato record valido: reset EOF
           MOVE ZERO TO RG-CZT-EOF.
           MOVE KEYCZT TO KRIFER.
           GO TO RNP-90.

      * trovato EOF/BOF: set EOF e ripristina chiave iniziale
       RNP-80.
           ADD EOF TO RG-CZT-EOF.
           IF RG-CZT-EOF = 4 MOVE 2 TO RG-CZT-EOF.
           PERFORM MOVE-KEY.

      * continua elaborazione con funzione Read
       RNP-90.
           IF FUN = 'n' OR 'p'
              MOVE 'r' TO FUN
           ELSE
              MOVE 'R' TO FUN.
       EX-READ-N-P.
      *------------------
      * test End Of File logico
      *    Nota: testare anche chiave < (per read previous)
      *
       TEST-EOL.
      *    IF RF-CZT = LOW-VALUE GO TO EX-TEST-EOL.
      *    IF KCZT-COD = RG-CZT-COD GO TO EX-TEST-EOL.
      *    IF FUN = 'P' OR 'p'
      *       MOVE 1 TO EOF
      *    ELSE
      *       MOVE 3 TO EOF.
       EX-TEST-EOL.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-CZT-COD      TO KCZT-COD.
           MOVE RG-CZT-AZI      TO KCZT-AZI.
           MOVE RG-CZT-UTE      TO KCZT-UTE.
      *
           MOVE RG-CZT-DES1      TO CZT-DES1.
           MOVE RG-CZT-DES2      TO CZT-DES2.
           MOVE RG-CZT-DES3      TO CZT-DES3.
      *
           MOVE 1 TO TIPOP1.
           MOVE RG-CZT-DATA TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO V-ERROR.
           MOVE AAGGG            TO CZT-DATA.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE KCZT-COD         TO RG-CZT-COD.
           MOVE KCZT-AZI         TO RG-CZT-AZI.
           MOVE KCZT-UTE         TO RG-CZT-UTE.
      *
           MOVE CZT-DES1         TO RG-CZT-DES1.
           MOVE CZT-DES2         TO RG-CZT-DES2.
           MOVE CZT-DES3         TO RG-CZT-DES3.
      *
           MOVE 2 TO TIPOP1.
           MOVE CZT-DATA TO AAGGG.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO PERFORM ERR-DATA GO TO V-ERROR.
           MOVE GGMMAA           TO RG-CZT-DATA.
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi chiave (NB: di RG-CZT-REC)
       V-CHIAVE.
           MOVE ZERO TO VFLD.
      *
       V-CZT-COD.
           MOVE 'CZT-COD' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CZT-COD.
           IF RG-CZT-COD = SPACE
              PERFORM ERR-ZERO
              GO TO V-ERROR.
       E-CZT-COD.
      *
       V-CZT-AZI.
           MOVE 'KCZT-AZI' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CZT-AZI.
       E-CZT-AZI.
      *
       V-CZT-UTE.
           MOVE 'KCZT-UTE' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CZT-UTE.
       E-CZT-UTE.
      *
           GO TO EX-V-CHIAVE-DATI.
      *------------------
      * validazione dei campi non chiave (NB: di RG-CZT-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
           IF FUN = 'w' GO TO V-DATI-DUPL.
      *
           IF FUN = 'W' GO TO V-END-DATI-DUPL.
       V-DATI-DUPL.
      *
       V-AZIARR.
           MOVE 'CZT-AZIARR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-AZIARR.
      *
           MOVE RG-CZT-AZIARR TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
       E-AZIARR.
      *
       V-UTEARR.
           MOVE 'CZT-UTEARR' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-UTEARR.
      *
           MOVE RG-CZT-UTEARR TO KTU-COD.
           READ TABUTE INVALID
                PERFORM ERR-CINE
                GO TO V-ERROR.
       E-UTEARR.
      *
       V-END-DATI-DUPL.
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
      * storno dati correlati
       DB-STORNA.
       EX-DB-STORNA.
           EXIT.
      *------------------
      * aggiornamento dati correlati
       DB-AGGIORNA.
       EX-DB-AGGIORNA.
           EXIT.
      *------------------
       DUPL.
      * testata
           MOVE RG-CZT-COD TO KCZT-COD.
           MOVE RG-CZT-AZI TO KCZT-AZI.
           MOVE RG-CZT-UTE TO KCZT-UTE.
           READ CFGZOT INVALID GO TO EX-DUPL.

           MOVE RG-CZT-AZIARR TO KCZT-AZI.
           MOVE RG-CZT-UTEARR TO KCZT-UTE.
           ACCEPT GGMMAA FROM DATE.
           MOVE GG9 TO AAGGG.
           MOVE AA9 TO GG9.
           MOVE AAGGG TO AA9.
           MOVE 1 TO TIPOP1.
           CALL 'rdata' USING PARCDT.
           MOVE AAGGG TO CZT-DATA.
       
           WRITE RF-CZT INVALID PERFORM INVK-CZT
                                GO TO ERRIO.
      *
      * righi
      *
           MOVE RG-CZT-COD TO KCZR-COD.
           MOVE RG-CZT-AZI TO KCZR-AZI.
           MOVE RG-CZT-UTE TO KCZR-UTE.
           MOVE LOW-VALUE  TO KCZR-FLD.
           START CFGZOR KEY NOT < KEYCZR INVALID KEY GO TO EX-DUPL-50.
       DUP-10.
           READ CFGZOR NEXT AT END GO TO EX-DUPL-50.
           IF SF-CZR = '9D' OR '9A' OR '35' GO TO DUP-10.
           IF KCZR-COD > RG-CZT-COD GO TO EX-DUPL-50.
           IF KCZR-AZI > RG-CZT-AZI GO TO EX-DUPL-50.
           IF KCZR-UTE > RG-CZT-UTE GO TO EX-DUPL-50.
        
           MOVE RG-CZT-COD    TO KCZR-COD.
           MOVE RG-CZT-AZIARR TO KCZR-AZI.
           MOVE RG-CZT-UTEARR TO KCZR-UTE.
           WRITE RF-CZR INVALID KEY PERFORM INVK-CZR
                                    GO TO ERRIO.
      *
      * riposiziono il cursore
           MOVE RG-CZT-COD TO KCZR-COD.
           MOVE RG-CZT-AZI TO KCZR-AZI.
           MOVE RG-CZT-UTE TO KCZR-UTE.
           READ CFGZOR INVALID PERFORM INVK-CZR
                              GO TO ERRIO.
       
           GO TO DUP-10.
       EX-DUPL-50.

       EX-DUPL.
           EXIT.
      *------------------
